pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 > Class Template Reference
Module filters

RadiusOutlierRemoval is a simple filter that removes outliers if the number of neighbors in a certain search radius is smaller than a given K. More...

`#include <pcl/filters/radius_outlier_removal.h>`

Inheritance diagram for pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >:

## Public Member Functions

| RadiusOutlierRemoval (bool extract_removed_indices=false)
| Empty constructor. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the k-nearest neighbors for filtering. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the k-nearest neighbors. More...
void | setMinNeighborsInRadius (int min_pts)
| Set the minimum number of neighbors that a point needs to have in the given search radius in order to be considered an inlier (i.e., valid). More...
double | getMinNeighborsInRadius ()
| Get the minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier and avoid being filtered. More...
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
| ~FilterIndices ()
| Empty virtual destructor. More...
virtual void | filter (PCLPointCloud2 &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
| ~Filter ()
| Empty destructor. More...
const IndicesConstPtr | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PCLPointCloud2ConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
const IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output) override
| Abstract filter method for point cloud. More...
void | applyFilter (std::vector< int > &indices) override
| Abstract filter method for point cloud indices. More...
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

double | search_radius_
| The nearest neighbors search radius for each point. More...
int | min_pts_radius_
| The minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier. More...
KdTreePtr | searcher_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
using | Ptr = shared_ptr< Filter< pcl::PCLPointCloud2 > >
using | ConstPtr = shared_ptr< const Filter< pcl::PCLPointCloud2 > >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

### template<>
class pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >

RadiusOutlierRemoval is a simple filter that removes outliers if the number of neighbors in a certain search radius is smaller than a given K.

Note
  setFilterFieldName (), setFilterLimits (), and setFilterLimitNegative () are ignored.

Author
  Radu Bogdan Rusu

Definition at line 192 of file radius_outlier_removal.h.

## Constructor & Destructor Documentation

## RadiusOutlierRemoval()

pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::RadiusOutlierRemoval | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 209 of file radius_outlier_removal.h.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

override protected virtual

Abstract filter method for point cloud.

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::applyFilter | ( | std::vector< int > & | indices | ) |

override protected virtual

Abstract filter method for point cloud indices.

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## getMinNeighborsInRadius()

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::getMinNeighborsInRadius | ( |  | ) |

inline

Get the minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier and avoid being filtered.

Definition at line 246 of file radius_outlier_removal.h.

## getRadiusSearch()

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::getRadiusSearch | ( |  | ) |

inline

Get the sphere radius used for determining the k-nearest neighbors.

Definition at line 227 of file radius_outlier_removal.h.

## setMinNeighborsInRadius()

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::setMinNeighborsInRadius | ( | int | min_pts | ) |

inline

Set the minimum number of neighbors that a point needs to have in the given search radius in order to be considered an inlier (i.e., valid).

Parameters

  min_pts | the minimum number of neighbors

Definition at line 237 of file radius_outlier_removal.h.

## setRadiusSearch()

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::setRadiusSearch | ( | double | radius | ) |

inline

Set the sphere radius that is to be used for determining the k-nearest neighbors for filtering.

Parameters

  radius | the sphere radius that is to contain all k-nearest neighbors

Definition at line 220 of file radius_outlier_removal.h.

## Member Data Documentation

## min_pts_radius_

int pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::min_pts_radius_

protected

The minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier.

Definition at line 258 of file radius_outlier_removal.h.

## search_radius_

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::search_radius_

protected

The nearest neighbors search radius for each point.

Definition at line 253 of file radius_outlier_removal.h.

## searcher_

KdTreePtr pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::searcher_

protected

A pointer to the spatial search object.

Definition at line 261 of file radius_outlier_removal.h.

The documentation for this class was generated from the following file:

- pcl/filters/radius_outlier_removal.h